VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDownload"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private sMySelf As String
Private sMySelfBak As String
Private cTarget As String
Private cDomain As String
Private cHandle As Long
Private cBak As String
Private mvarDomainAddress As String
Private mvarLocalPath As String
Private mvarUserId As String
Private mvarPassword As String
Private mvarKey As Variant 'local copy
Public Property Let Key(ByVal vData As Variant)
    mvarKey = vData
End Property


Public Property Set Key(ByVal vData As Variant)
    Set mvarKey = vData
End Property


Public Property Get Key() As Variant
Attribute Key.VB_UserMemId = 0
    If IsObject(mvarKey) Then
        Set Key = mvarKey
    Else
        Key = mvarKey
    End If
End Property



Public Property Let Password(ByVal vData As String)
    mvarPassword = vData
End Property


Public Property Get Password() As String
    Password = mvarPassword
End Property



Public Property Let UserId(ByVal vData As String)
    mvarUserId = vData
End Property


Public Property Get UserId() As String
    UserId = mvarUserId
End Property

Public Property Let LocalPath(ByVal vData As String)
    mvarLocalPath = vData
End Property

Public Property Get LocalPath() As String
    LocalPath = mvarLocalPath
End Property

Public Property Let DomainAddress(ByVal vData As String)
    mvarDomainAddress = vData
End Property

Public Property Get DomainAddress() As String
    DomainAddress = mvarDomainAddress
End Property

Public Sub Commit()
    'rename the files if possible
    On Error Resume Next
    If cBak > "" Then
        If Dir$(cBak) > "" Then
            If cTarget > "" Then
                KillSafe cTarget
                If Dir$(cTarget) = "" Then
                    Name cBak As cTarget
                End If
            End If
        End If
    End If
End Sub

Public Function DownloadHandle() As Long
    DownloadHandle = cHandle
End Function

Public Function Target() As String
    Target = cTarget
End Function

Public Function Domain() As String
    Domain = cDomain
End Function


Public Function GetWEBResponse(Optional ByVal sDomain As String = "", Optional ByVal sUser As String = "", Optional ByVal sPwd As String = "") As Long
    If sDomain = "" Then sDomain = mvarDomainAddress
    If sUser = "" Then sUser = mvarUserId
    If sPwd = "" Then sPwd = mvarPassword
    
    cHandle = WEBResponse(sDomain, sUser, sPwd, frmNotifications.txtDownloadError.hWnd, frmNotifications.txtDownloadProgress.hWnd, frmNotifications.txtWEBResponse.hWnd, 1)
    'in VB 5.0 this should work too
    'cHandle = WEBResponse(sDomain, sUser, sPwd, AddressOf REDnload_Error, AddressOf REDnload_Progress, AddressOf REDnload_WEBResponseCallback, 1)
End Function
Public Function UpdateExecutable(Optional ByVal sDomain As String = "", Optional ByVal sLocalFile As String = "", Optional ByVal sUser As String = "", Optional ByVal sPwd As String = "") As Long
    'sDomain is acceptable in the following forms
    'sDomain = "http://www.direct-print.com/ThisClient.exe"
    'sDomain = "http://www.direct-print.com/Subdir/ThisClient.exe"
    'sDomain = "http://172.16.1.65/ThisClient.exe"
    'sDomain = "http://172.16.1.65/Subdir/ThisClient.exe"
    Dim i As Long
    Dim sFileBase As String
    Dim sExt As String
    Dim sHdr As String
    Dim sRoot As String
    
    Dim sTarget As String
    Dim sReply As String
    
    Dim iNull As Long
    Dim iRes As Long
    Dim remSize As Long
    Dim locSize As Long
    Dim remDate As String
    Dim locDate As String
    Dim locDateUTC As String
    Dim UTCoffset As Single
    Dim remDateAsLocal As String
    Dim sIni As String
    Dim bOK As Boolean
    
    If sDomain = "" Then sDomain = mvarDomainAddress
    If sLocalFile = "" Then sLocalFile = mvarLocalPath
    If sUser = "" Then sUser = mvarUserId
    If sPwd = "" Then sPwd = mvarPassword
    
    cDomain = sDomain
    cTarget = sLocalFile
    sMySelf = sLocalFile
    Do
        i = i + 1
        sMySelfBak = WithSlash(ExtractPath(sMySelf)) & ExtractBase(sMySelf) & Format$(i) & "." & ExtractExtension(sMySelf)
    Loop Until Len(Dir$(sMySelfBak)) = 0    'so the file does not exist
    cBak = sMySelfBak
    If Len(Dir$(sMySelf)) > 0 Then  'get the size and the date of the file if exists
        locSize = FileLen(sMySelf)
        locDate = FileDateTime(sMySelf)
    End If
    UTCoffset = HoursToUTC() * 60   'get the UTC offset in minutes
    'contact the server and ask about the remote file
    remSize = HTTPRemoteFileInfo(cDomain, remDate)
    'convert the remote date to a valid windows date format
    If remDate > "" Then
        remDate = Format$(Trim$(Replace(Mid$(remDate, 6), "GMT", "")), "mm/dd/yyyy hh:nn:ss")
    Else
        'no remote source
        UpdateExecutable = -1
        Exit Function
    End If
    'figure out the remote date by local time zone
    remDateAsLocal = DateAdd("n", UTCoffset, remDate)
    'download the file only if the dates are different and the remote file was found
    If remDateAsLocal <> locDate And Len(remDateAsLocal) And Len(locDate) Then
        bOK = True
    ElseIf locDate = "" Then
        bOK = True
    End If
    
    If bOK Then
        'download as sMySelfBak asynchronously
        'in VB 5.0 the following remmed out line should work. In VB 6.0 will crash (at least sometimes)
        'cHandle = HTTPDownloadAsync(sDomain, sMySelfBak, sUser, sPwd, AddressOf REDnload_Error, AddressOf REDnload_Progress, AddressOf REDnload_Done)
        cHandle = HTTPDownloadAsync1(sDomain, sMySelfBak, sUser, sPwd, frmNotifications.txtDownloadError.hWnd, frmNotifications.txtDownloadProgress.hWnd, frmNotifications.txtDone.hWnd)
        'at this point we are done. The download has started, we need to monitor our callback functions
        UpdateExecutable = cHandle
    Else
        UpdateExecutable = -1   'flags there is nothing to do
    End If
End Function
Public Sub CancelJob(Optional ByVal bAllJobs As Boolean = False)
    If bAllJobs Then
        CancelJobs -100
    Else
        CancelJobs cHandle
    End If
End Sub
Public Function License(ByVal OrderId As String, ByVal sPassword As String) As Boolean
    Dim vPassword As Variant
    Dim i As Long
    Dim sCode As String
    Dim bLicensed As Boolean
    
    vPassword = Split(sPassword, ",")
    sCode = ""
    For i = 0 To UBound(vPassword)
        sCode = sCode & Chr$(vPassword(i))
    Next
    bLicensed = CheckAuthorization(OrderId, sCode)
    
    License = bLicensed
End Function
