VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDownloads"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsDownload"
Attribute VB_Ext_KEY = "Member0" ,"clsDownload"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mCol As Collection
Public Event Done(ByVal nd As Long, ByVal sLocalFile As String)
Public Event DownloadError(ByVal nd As Long, ByVal sErrMsg As String, ByVal sLocalFile As String)
Public Event DownloadProgress(ByVal nd As Long, ByVal percentage As Long, cancel As Boolean)
Public Event TotalDownloadBytes(ByVal total As Long)
Public Event WEBResponse(ByVal nd As Long, ByVal sData As String)
Public Function Add(DomainAddress As String, LocalPath As String, UserId As String, Password As String, Optional sKey As String) As clsDownload
    'create a new object
    Dim objNewMember As clsDownload
    Set objNewMember = New clsDownload


    'set the properties passed into the method
    objNewMember.DomainAddress = DomainAddress
    objNewMember.LocalPath = LocalPath
    objNewMember.UserId = UserId
    objNewMember.Password = Password
    objNewMember.Key = sKey
    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If


    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function

Public Property Get Item(vntIndexKey As Variant) As clsDownload
    Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    mCol.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    Load frmNotifications
    Set mCol = New Collection
    cDnPtr = ObjPtr(Me)
    ReDim ArrdoneBytes(0)
End Sub


Private Sub Class_Terminate()
    Unload frmNotifications
    Set mCol = Nothing
End Sub

Friend Function Fire_Done(ByVal nd As Long)
    Dim locFile As String
    Dim vKey As Variant
    Dim objDownload As clsDownload
    'Commit and remove it from the collection
    vKey = -1
    For Each objDownload In mCol
        vKey = vKey + 1
        If objDownload.DownloadHandle = nd Then
            locFile = objDownload.LocalPath
            objDownload.Commit
            Me.Remove objDownload.Key
        End If
    Next
    RaiseEvent Done(nd, locFile)
End Function
Friend Function Fire_DownloadError(ByVal nd As Long, ByVal sErrMsg As String)
    Dim vKey As Variant
    Dim locFile As String
    Dim objDownload As clsDownload
    
    On Error GoTo errSub
    
    vKey = -1
    For Each objDownload In mCol
        vKey = vKey + 1
        If objDownload.DownloadHandle = nd Then
            locFile = objDownload.LocalPath
            Me.Remove objDownload.Key
        End If
    Next
    RaiseEvent DownloadError(nd, sErrMsg, locFile)
    Exit Function
errSub:
    Debug.Print "Fire_DownloadError:Err.HelpContext"
End Function
Friend Function Fire_DownloadProgress(ByVal nd As Long, ByVal percentage As Long, cancel As Long)
    Dim bCancel As Boolean
    RaiseEvent DownloadProgress(nd, percentage, bCancel)
    cancel = CLng(bCancel)
End Function
Friend Function Fire_TotalDownloadBytes(ByVal total As Long)
    RaiseEvent TotalDownloadBytes(total)
End Function
Friend Function Fire_WEBResponse(ByVal nd As Long, ByVal sData As String)
    RaiseEvent WEBResponse(nd, sData)
End Function

Public Sub InitBytesCount()
    ReDim ArrdoneBytes(0)
End Sub
